VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'******* 01.30a Start *******
' Added class
'******* 01.30a End *********

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type Point
    X As Long
    Y As Long
End Type

Private Declare Sub ClipCursor Lib "user32" (lpRect As Any)
Private Declare Sub GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT)
Private Declare Sub ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As Point)
Private Declare Sub OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long)
Private mlngXNdx As Long
Private mlngYNdx As Long
Private mintSLOP As Integer

Private Type typRECT
    Left As Single
    Top As Single
    Width As Single
    Height As Single
End Type

Private mRect As typRECT
Private mbRectDrawn As Boolean
Private mSourcePicBox As PictureBox
Private mCropPicBox As PictureBox
Private mshpRect As Shape
Private msngOrigX As Single
Private msngOrigY As Single
Private mbInitialized As String
Private mbStretching As Boolean

Private Enum GrabHandle
    BLCorner
    BRCorner
    TLCorner
    TRCorner
    RSide
    LSide
    TSide
    BSide
    Inside
    None = 99
End Enum
Private CurrentGrabHandle As GrabHandle

Private msngMouseX As Single
Private msngMouseY As Single

Private mlngDIBFull As Long
Private mlngDIBCropped As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Private Sub RestrictCursor()
'***************************************************************************
'Purpose: Limit the mouse to the boundaries of the picturebox
'Inputs :
'Outputs:
'***************************************************************************

    Dim client As RECT
    Dim upperleft As Point
    
    'Get information about our window
    GetClientRect SourcePB.hWnd, client
    upperleft.X = client.Left
    upperleft.Y = client.Top
    'Convert window cordinates to screen cordinates
    ClientToScreen SourcePB.hWnd, upperleft
    'move our rectangle
    OffsetRect client, upperleft.X, upperleft.Y
    'limit the cursor movement
    ClipCursor client

End Sub

Private Sub ReleaseCursor()
'***************************************************************************
'Purpose: Release the mouse from the boundaries of the picturebox
'Inputs :
'Outputs:
'***************************************************************************
    
    ClipCursor ByVal 0&

End Sub
Private Function RightSide(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the right side of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left + .Width Then
                If Y > .Top And Y < .Top + .Height Then
                    RightSide = True
                    Exit Function
                End If
            End If
        Next
    End With
    
End Function
Private Function LeftSide(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the left side of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left Then
                If Y > .Top - SLOP And Y < .Top + .Height + SLOP Then
                    LeftSide = True
                    Exit Function
                End If
            End If
        Next
    End With
    
End Function
Private Function TopSide(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the top of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************

    With mRect
        For mlngYNdx = Y - SLOP To Y + SLOP
            If mlngYNdx = .Top Then
                ' SLOP is included here so as not to conflict with the corners
                If X > .Left + SLOP And X < .Left + .Width - SLOP Then
                    TopSide = True
                    Exit Function
                End If
            End If
        Next
    End With
    
End Function
Private Function BottomSide(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the bottom of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************

    With mRect
        For mlngYNdx = Y - SLOP To Y + SLOP
            If mlngYNdx = .Top + .Height Then
                ' SLOP is included here so as not to conflict with the corners
                If X > .Left + SLOP And X < .Left + .Width - SLOP Then
                    BottomSide = True
                    Exit Function
                End If
            End If
        Next
    End With
    
End Function

Private Function BottomRightCorner(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the bottom right corner of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left + .Width Then
                For mlngYNdx = Y - SLOP To Y + SLOP
                    If mlngYNdx = .Top + .Height Then
                        BottomRightCorner = True
                        Exit Function
                    End If
                Next
            End If
        Next
    End With
    
End Function
Private Function BottomLeftCorner(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the bottom left corner of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left Then
                For mlngYNdx = Y - SLOP To Y + SLOP
                    If mlngYNdx = .Top + .Height Then
                        BottomLeftCorner = True
                        Exit Function
                    End If
                Next
            End If
        Next
    End With
    
End Function
Private Function TopLeftCorner(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the top left corner of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left Then
                For mlngYNdx = Y - SLOP To Y + SLOP
                    If mlngYNdx = .Top Then
                        TopLeftCorner = True
                        Exit Function
                    End If
                Next
            End If
        Next
    End With
    
End Function
Private Function TopRightCorner(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is touching the top right corner of the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
    
    With mRect
        For mlngXNdx = X - SLOP To X + SLOP
            If mlngXNdx = .Left + .Width Then
                For mlngYNdx = Y - SLOP To Y + SLOP
                    If mlngYNdx = .Top Then
                        TopRightCorner = True
                        Exit Function
                    End If
                Next
            End If
        Next
    End With
    
End Function
Private Function InsideRect(X As Single, Y As Single) As Boolean
'***************************************************************************
'Purpose: Determine if the mouse is inside the rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs: True or False
'***************************************************************************
   
    With mRect
        If X > .Left And X < .Left + .Width And _
           Y > .Top And Y < .Top + .Height Then
            InsideRect = True
        End If
    End With
    
End Function
Private Property Get SLOP() As Integer
'***************************************************************************
'Purpose: SLOP adds a "fudge factor" that makes it easier for the user to
'         "touch" a particular point on the rectangle
'Inputs :
'Outputs:
'***************************************************************************

    SLOP = mintSLOP

End Property

Public Property Let SLOP(ByVal intNew As Integer)
    ' SLOP is a parameter that essentially widens the sides of the rectangle so as
    ' to make it easier to "grab" it. The default is 10 and that can be changed but
    ' too large a parameter will cause problems.

    mintSLOP = intNew

End Property

Private Sub Class_Initialize()

    SLOP = 10
    Initialized = False
    
End Sub

Public Sub Stretch(X As Single, Y As Single)
'***************************************************************************
'Purpose: Stretch or shrink the already drawn rectangle
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs:
'***************************************************************************

    Dim sngLeft As Single
    Dim sngTop As Single
    Dim sngRight As Single
    Dim sngBottom As Single
    
    With mRect
        sngLeft = .Left
        sngTop = .Top
        sngRight = .Left + .Width
        sngBottom = .Top + .Height
    End With
    
    'RestrictCursor
    
    Select Case CurrentGrabHandle
        Case BLCorner
            DragRectangle X, sngTop, sngRight, Y
        Case BRCorner
            DragRectangle sngLeft, sngTop, X, Y
        Case TLCorner
            DragRectangle X, Y, sngRight, sngBottom
        Case TRCorner
            DragRectangle sngLeft, Y, X, sngBottom
        Case RSide
            DragRectangle sngLeft, sngTop, X, sngBottom
        Case LSide
            DragRectangle X, sngTop, sngRight, sngBottom
        Case TSide
            DragRectangle sngLeft, Y, sngRight, sngBottom
        Case BSide
            DragRectangle sngLeft, sngTop, sngRight, Y
        Case Inside
            MoveRectangle sngLeft, sngTop, X, Y
    End Select

End Sub

Public Sub ShowGrabHandles(X As Single, Y As Single)
'***************************************************************************
'Purpose: Show different mouse pointers depending on where the mouse is
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs:
'***************************************************************************
    
    Select Case True
        ' The four corners need to be checked first
        '******* 01.40i Start *******
'        Case BottomLeftCorner(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ne_02.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 0
'        Case BottomRightCorner(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\nw_07.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 1
'        Case TopLeftCorner(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\nw_07.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 2
'        Case TopRightCorner(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ne_02.cur")
'            SourcePB.MousePointer = vbCustom
'        ' Now we can check the sides
'            CurrentGrabHandle = 3
'        Case RightSide(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ew_07.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 4
'        Case LeftSide(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ew_07.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 5
'       Case TopSide(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ns_05.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 6
'        Case BottomSide(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\ns_05.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 7
'        Case InsideRect(X, Y)
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\4way02.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 8
'        Case Else
'            SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\crop.cur")
'            SourcePB.MousePointer = vbCustom
'            CurrentGrabHandle = 99
'    End Select
        Case BottomLeftCorner(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthEast, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 0
        Case BottomRightCorner(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthWest, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 1
        Case TopLeftCorner(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthWest, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 2
        Case TopRightCorner(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthEast, vbResCursor)
            SourcePB.MousePointer = vbCustom
        ' Now we can check the sides
            CurrentGrabHandle = 3
        Case RightSide(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curEastWest, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 4
        Case LeftSide(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curEastWest, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 5
        Case TopSide(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthSouth, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 6
        Case BottomSide(X, Y)
            SourcePB.MouseIcon = LoadResPicture(curNorthSouth, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 7
        Case InsideRect(X, Y)
            SourcePB.MouseIcon = LoadResPicture(cur4Way, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 8
        Case Else
            SourcePB.MouseIcon = LoadResPicture(curCrop, vbResCursor)
            SourcePB.MousePointer = vbCustom
            CurrentGrabHandle = 99
    End Select
        '******* 01.40i End *********

End Sub

Public Sub DrawInitial(X As Single, Y As Single)
'***************************************************************************
'Purpose: Draw the rectangle starting the mouse coordinates
'Inputs : X - The X cooridinate of the mouse
'         Y - The Y cooridinate of the mouse
'Outputs:
'***************************************************************************

    DragRectangle OriginX, OriginY, X, Y
    
End Sub
Private Sub DragRectangle(X1 As Single, Y1 As Single, x2 As Single, Y2 As Single)
'***************************************************************************
'Purpose: Drag a side or corner of the rectangle and then flip the grab
'         point the if coordinates cross
'Inputs : X1 - The X cooridinate of the mouse or the rectangle
'         X2 - The X cooridinate of the mouse or the rectangle
'         Y1 - The Y cooridinate of the mouse or the rectangle
'         Y2 - The Y cooridinate of the mouse or the rectangle
'Outputs:
'***************************************************************************

    Dim bFlipX As Boolean
    Dim bFlipY As Boolean

    RestrictCursor
    
    With mRect
        If X1 <= x2 Then
            .Left = X1
            .Width = x2 - X1
        Else
            .Left = x2
            .Width = X1 - x2
            bFlipX = True
        End If
        If Y1 <= Y2 Then
            .Top = Y1
            .Height = Y2 - Y1
        Else
            .Top = Y2
            .Height = Y1 - Y2
            bFlipY = True
        End If
        CropRect.Move .Left, .Top, .Width, .Height
    End With
    If bFlipX Then
        Select Case CurrentGrabHandle
            Case BLCorner
                CurrentGrabHandle = BRCorner
            Case BRCorner
                CurrentGrabHandle = BLCorner
            Case TLCorner
                CurrentGrabHandle = TRCorner
            Case TRCorner
                CurrentGrabHandle = TLCorner
            Case RSide
                CurrentGrabHandle = LSide
            Case LSide
                CurrentGrabHandle = RSide
        End Select
    End If
    If bFlipY Then
        Select Case CurrentGrabHandle
            Case BLCorner
                CurrentGrabHandle = TLCorner
            Case BRCorner
                CurrentGrabHandle = TRCorner
            Case TLCorner
                CurrentGrabHandle = BLCorner
            Case TRCorner
                CurrentGrabHandle = BRCorner
            Case TSide
                CurrentGrabHandle = BSide
            Case BSide
                CurrentGrabHandle = TSide
        End Select
    End If
   
    ReleaseCursor
End Sub
Public Property Get RectangleDrawn() As Boolean
'***************************************************************************
'Purpose: Indicates if the rectangle has been drawn
'Inputs :
'Outputs: True or False
'***************************************************************************

    RectangleDrawn = mbRectDrawn

End Property

Public Property Let RectangleDrawn(ByVal bTF As Boolean)

    mbRectDrawn = bTF

End Property
Public Sub Start(ShapeRect As Shape, X As Single, Y As Single, Optional pbCrop As PictureBox = Nothing)
'***************************************************************************
'Purpose: Set values and objects that are needed by this class
'Inputs : ShapeRect - The name of the Shape control on the picturebox. The
'                     Container property of the Shape control is used to
'                     determine the name of the picturebox.
'         X - The X cooridinate of the mouse click
'         Y - The Y cooridinate of the mouse click
'         pbCrop - The name of the preview picturebox if one exists
'Outputs:
'***************************************************************************

    OriginX = X
    OriginY = Y
    With mRect
        .Left = X
        .Top = Y
    End With

    Set CropRect = ShapeRect
    Set SourcePB = ShapeRect.Container
    
    If Not pbCrop Is Nothing Then
        Set CropPB = pbCrop
    End If
    
    '******* 01.40i Start *******
    'SourcePB.MouseIcon = LoadPicture(App.Path & "\graphics\crop.cur")
    SourcePB.MouseIcon = LoadResPicture(curCrop, vbResCursor)
    '******* 01.40i End *********

    SourcePB.MousePointer = vbCustom

    CropRect.Move X, Y, 0, 0
    CropRect.Visible = True
    Initialized = True

End Sub
Private Property Get SourcePB() As PictureBox
'***************************************************************************
'Purpose: Sets the value of the source picturebox object to be used by this class
'Inputs :
'Outputs:
'***************************************************************************

    Set SourcePB = mSourcePicBox

End Property

Private Property Set SourcePB(ByVal PB As PictureBox)

    Set mSourcePicBox = PB

End Property
Private Property Get CropPB() As PictureBox
'***************************************************************************
'Purpose: Sets the value of the preview picturebox object to be used by this class
'Inputs :
'Outputs:
'***************************************************************************

    Set CropPB = mCropPicBox

End Property

Private Property Set CropPB(ByVal PB As PictureBox)

    Set mCropPicBox = PB

End Property

Private Property Get CropRect() As Shape
'***************************************************************************
'Purpose: Sets the value of the Shape object to be used by this class
'Inputs :
'Outputs:
'***************************************************************************

    Set CropRect = mshpRect
    
End Property

Private Property Set CropRect(ByVal shp As Shape)

    Set mshpRect = shp

End Property
Private Property Get OriginX() As Single
'***************************************************************************
'Purpose: Get/Let the X coordinate of the mouse click that starts the
'         drawing of a rectangle
'Inputs :
'Outputs:
'***************************************************************************

    OriginX = msngOrigX

End Property

Private Property Let OriginX(ByVal sngOrigin As Single)

    msngOrigX = sngOrigin

End Property
Private Property Get OriginY() As Single
'***************************************************************************
'Purpose: Get/Let the Y coordinate of the mouse click that starts the
'         drawing of a rectangle
'Inputs :
'Outputs:
'***************************************************************************

    OriginY = msngOrigY

End Property

Private Property Let OriginY(ByVal sngOrigin As Single)

    msngOrigY = sngOrigin

End Property
Public Property Get Initialized() As Boolean
'***************************************************************************
'Purpose: Determines if the class' values have been initialied
'Inputs :
'Outputs:
'***************************************************************************
    
    Initialized = mbInitialized

End Property

Private Property Let Initialized(ByVal bTF As Boolean)

    mbInitialized = bTF

End Property

Public Property Get Stretching() As Boolean

    Stretching = mbStretching

End Property

Public Property Let Stretching(ByVal bTF As Boolean)
'***************************************************************************
'Purpose: Determines if the rectangle is being stretched or shrunk
'Inputs :
'Outputs:
'***************************************************************************

    mbStretching = bTF

End Property

Private Property Get MouseDownX() As Single
'***************************************************************************
'Purpose: Get/Let the X coordinate of any mouse click that happens after the
'         rectangle has been drawn. This parameter is only needed to do
'         the movement of the rectangle when the user clicks inside it.
'Inputs :
'Outputs:
'***************************************************************************

    MouseDownX = msngMouseX

End Property

Private Property Let MouseDownX(ByVal sngNew As Single)

    msngMouseX = sngNew

End Property
Private Property Get MouseDownY() As Single
'***************************************************************************
'Purpose: Get/Let the Y coordinate of any mouse click that happens after the
'         rectangle has been drawn. This parameter is only needed to do
'         the movement of the rectangle when the user clicks inside it.
'Inputs :
'Outputs:
'***************************************************************************

    MouseDownY = msngMouseY

End Property

Private Property Let MouseDownY(ByVal sngNew As Single)

    msngMouseY = sngNew

End Property
Public Sub SaveMouse(X As Single, Y As Single)
'***************************************************************************
'Purpose: See MouseDownX and MouseDownY
'Inputs :
'Outputs:
'***************************************************************************
        
    MouseDownX = X
    MouseDownY = Y
    
    With mRect
        If X < .Left - SLOP Or X > .Left + .Width + SLOP _
                     Or Y < .Top - SLOP Or Y > .Top + .Height + SLOP Then
            ' The user has clicked the mouse outside the rectangle, and the class
            ' interprets that as an indication that the user wants to draw
            ' a completely new rectangle
            SourcePB.Container.Controls(CropRect.Name).Visible = False
            RectangleDrawn = False
            If Not CropPB Is Nothing Then
                Set CropPB.Picture = Nothing
            End If
            Start CropRect, X, Y
        End If
    End With

End Sub

Public Sub MoveRectangle(sngLeft As Single, sngTop As Single, X As Single, Y As Single)
'***************************************************************************
'Purpose: Move the rectangle around the picturebox
'Inputs : sngLeft - The X coordinate of the rectangle's left side
'         sngTop - The Y coordinate of the rectangle's top side
'         X - The X coordinate of the mouse
'         Y - The Y coordinate of the mouse
'Outputs:
'***************************************************************************

        With mRect
            .Left = sngLeft - (MouseDownX - X)
            .Top = sngTop + (Y - MouseDownY)
            ' Restrict the rectangle to the picturebox boundaries
            If .Left < 0 Then
                .Left = 0
            ElseIf .Left + .Width > SourcePB.ScaleWidth Then
                .Left = SourcePB.ScaleWidth - .Width
            End If
            If .Top < 0 Then
                .Top = 0
            ElseIf .Top + .Height > SourcePB.ScaleHeight Then
                .Top = SourcePB.ScaleHeight - .Height
            End If
        End With
        CropRect.Move sngLeft, sngTop
        
        MouseDownX = X
        MouseDownY = Y

End Sub
Public Sub Crop(pbSource As PictureBox)
'***************************************************************************
'Purpose: Crop the image in the source picturebox at the boundaries of the
'         rectangle
'Inputs : pbSource - The picturebox that containes the image to be cropped
'Outputs:
'***************************************************************************
'
    Set pbSource.Picture = pbSource.Image
    ' get FIBITMAP from OLE Picture
    mlngDIBFull = FreeImage_CreateFromOlePicture(pbSource.Picture)
    
    ' FreeImage_Copy does not use Width and Height but rather Right and Bottom!
    mlngDIBCropped = FreeImage_Copy(mlngDIBFull, mRect.Left, mRect.Top, mRect.Left + mRect.Width, _
                                 mRect.Top + mRect.Height)
    
    
End Sub
Public Sub CreateJPEG(strFileName As String, sngExpand As Single)
'***************************************************************************
'Purpose: Create a JPEG picture from the cropped image
'Inputs : strFileName - The JPEG's name and path
'Outputs:
'***************************************************************************

    Dim bSuccess As Boolean
    Dim intExpandFactor As Integer
    
    intExpandFactor = mRect.Width * sngExpand
    
    ' Save and unload the cropped image
    ' intExpandFactor is the Width * a multiplier. It must be an integer and if
    '                 the neaxt parameter (height) is omitted the picture is
    '                 sized proportionally
    ' The last parameter 'True' is bUnloadSource
    bSuccess = FreeImage_SaveEx(mlngDIBCropped, strFileName, , , , intExpandFactor, , , , True)

    If bSuccess Then
        MsgBox strFileName & " created"
    Else
        MsgBox strFileName & " not created"
    End If
    
    ' unload the uncropped image mlngDIBFull - a must
    FreeImage_Unload mlngDIBFull

End Sub

Public Sub FillCropPic(pbSource As PictureBox, pbCrop As PictureBox)
'***************************************************************************
'Purpose: Create the preview picture of the cropped area
'Inputs : pbSource - The source pcturebox
'         pbCrop - The picturebox where the preview picture is shown
'Outputs:
'***************************************************************************

    Dim sngRatioW As Single
    Dim sngRatioH As Single
    
    '******* 01.40b Start *******
    ' This is here because if the user tries real hard he can create a rectangle
    ' with 0 length or width and that causes division by zero errors.
    On Error Resume Next
    '******* 01.40b End *********
    
    If mRect.Width > mRect.Height Then
        sngRatioW = 1
        sngRatioH = mRect.Width / mRect.Height
    Else
        sngRatioW = mRect.Height / mRect.Width
        sngRatioH = 1
    End If

    With pbCrop
        StretchBlt .hdc, _
                   0, _
                   0, _
                   .ScaleWidth / sngRatioW, _
                   .ScaleHeight / sngRatioH, _
                   pbSource.hdc, _
                   mRect.Left, _
                   mRect.Top, _
                   mRect.Width, _
                   mRect.Height, _
                   vbSrcCopy
    End With
' hdcDest - Identifies the destination device context.
' nXOriginDest - Specifies the x-coordinate, in logical units, of the upper-left corner of the destination rectangle.
' nYOriginDest - Specifies the y-coordinate, in logical units, of the upper-left corner of the destination rectangle.
' nWidthDest - Specifies the width, in logical units, of the destination rectangle.
' nHeightDest - Specifies the height, in logical units, of the destination rectangle.
' hdcSrc - Identifies the source device context.
' nXOriginSrc - Specifies the x-coordinate, in logical units, of the upper-left corner of the source rectangle.
' nYOriginSrc - Specifies the y-coordinate, in logical units, of the upper-left corner of the source rectangle.
' nWidthSrc - Specifies the width, in logical units, of the source rectangle.
' nHeightSrc - Specifies the height, in logical units, of the source rectangle.
' dwRop - Specifies the raster operation to be performed.

End Sub


